<template>
  <b-modal
    id="modal-lg"
    size="lg"
    title="Ajouter des données"
    scrollable
    visible
    @hidden="close"
    @ok="close"
  >
    <b-tabs
      v-model="tabIndex"
      class="h-100"
      justified
    >
      <b-tab
        v-if="generalConfig.catalog"
        title="Catalogue"
        title-link-class="custom-tabs"
        active
      >
        <CatalogSearch v-on:selectLayer="selectCatalogLayer($event)"/>
      </b-tab>

      <b-tab
        v-if="generalConfig.osm"
        id="basemap"
        title="Fonds de Plan"
        title-link-class="custom-tabs"
      >
        <b-container fluid class="p-4">
          <b-row class="mb-2">
            <span class="italic">
              Cliquez sur une image pour ajouter le fond de plan correspondant à la carte
            </span>
          </b-row>
          <b-row>
            <b-col cols="12" md="4">
              <div class="thumbnail-wrapper">
                <b-img thumbnail fluid src="img/basemaps/osm.png"
                alt="OpenStreet map" @click="addOSM()"></b-img>
                <span class="img_caption">OpenStreetMap</span>
              </div>
            </b-col>
            <b-col cols="12" md="4">
              <div class="thumbnail-wrapper">
                <b-img thumbnail fluid src="img/basemaps/plan.png"
                alt="Plan IGN"  @click="addIGN()"></b-img>
                <span class="img_caption">Plan IGN</span>
              </div>
            </b-col>
            <b-col cols="12" md="4">
              <div class="thumbnail-wrapper">
                <b-img thumbnail fluid src="img/basemaps/ortho.png"
                alt="Ortho Photographie" @click="addIGNOrtho()"></b-img>
                <span class="img_caption">Photographies aériennes</span>
              </div>
            </b-col>
          </b-row>
          <b-row class="mt-1 mb-2">
            <span class="italic">
              Ci dessous le fond de plan IGN en vecteur tuilé avec différents styles
            </span>
          </b-row>
          <b-row>
            <b-col cols="12" md="4">
              <div class="thumbnail-wrapper">
                <b-img thumbnail fluid src="img/basemaps/mvt_gris.png"
                alt="Plan IGN"  @click="addVectorTilePlanIGN('gris')"></b-img>
                <span class="img_caption">Plan IGN : Vecteur Tuilé Gris</span>
              </div>
            </b-col>
              <b-col cols="12" md="4">
                <div class="thumbnail-wrapper">
                  <b-img thumbnail fluid src="img/basemaps/mvt_standard.png"
                  alt="Plan IGN"  @click="addVectorTilePlanIGN('standard')"></b-img>
                  <span class="img_caption">Plan IGN : Vecteur Tuilé standard</span>
                </div>
            </b-col>
              <b-col cols="12" md="4">
                <div class="thumbnail-wrapper">
                  <b-img thumbnail fluid src="img/basemaps/mvt_classique.png"
                  alt="Plan IGN"  @click="addVectorTilePlanIGN('classique')"></b-img>
                  <span class="img_caption">Plan IGN : Vecteur Tuilé classique</span>
                </div>
            </b-col>
          </b-row>
        </b-container>
      </b-tab>

      <b-tab
        v-if="generalConfig.ogc"
        class="h-100"
        title-link-class="custom-tabs"
      >
         <template #title>WMS, WFS, WMTS</template>
        <b-alert
          v-if="errorTxt !== null"
          show
          variant="warning"
          dismissible
        >
          {{errorTxt}}
        </b-alert>
        <div v-if="resultsLoaded==false" class="mt-4">
          <p>
            Choisissez un serveur dans la liste ou renseignez directement l'url du service.<br/>
            Vous devez renseignez l'url de l'opération GetCapabilities<br/>
            permettant de découvrir les couches mise à disposition par le service.<br/>
            Pour plus d'informations : <a href="https://docs.geoserver.org/latest/en/user/services/wms/reference.html"
            target="_blank">Documentation Geoserver</a>
          </p>
          <b-form-row>
            <b-col cols="4">
              <label>Serveur</label>
              <b-form-select v-model="selectedServer" :options="serverList"
                v-on:change="selectOGCServer()"></b-form-select>
            </b-col>
            <b-col cols="6">
              <label>Url</label>
              <input type="text" name="url" class="form-control"
                  v-model="url" placeholder="url du service WMS/WFS/WMTS" />
            </b-col>
            <b-col cols="2" align-self="end">
              <b-button variant="light" :pressed.sync="showAuthInfos" >
                <b-icon
                  :icon="authenticationInfos.isFilled()?'lock':'unlock'" variant="info"></b-icon>
              </b-button>
            </b-col>
          </b-form-row>
          <AuthenticationInfoPanel
            v-if="showAuthInfos" :url="url"
            :authenticationInfos="authenticationInfos"/>
          <br/>
          <center>
            <b-button
              v-if="!loading"
              variant="outline-primary"
              title="Connexion"
              class="bg_color-first-outlined"
              @click="connectServer()"
            >
              Connexion&nbsp;<b-icon icon="arrow-right"/>
            </b-button>
            <br/>
          </center>
        </div>
        <center>
           <div v-if="loading" class="loading">
              <b-button variant="primary" disabled>
                <b-spinner small type="grow"></b-spinner>
                Chargement...
              </b-button>
            </div>
        </center>
        <div v-if="resultList!=null && !loading" class="mb-5">
          <div class="result_header">
              <h4 class="result_title">
                <span v-if="(layerList && layerList.length>0) || filter.length > 0 ">
                  {{ layerList.length }}&nbsp;résultats
                </span>
                <span v-else>
                  Résultats
                </span>
              </h4>
              <input
                style="max-width:400px;display:inline-block;"
                v-model="filter"
                class="form-control"
                type="text"
                @input="filterChange()"
                placeholder="Filtrer les résultats"
              >
          </div>
          <div class="resultList">
            <div
              v-for="result of layerList"
              :key="result.id"
              :class="['resultItem', { 'selected': isSelected(result) }]"
            >
              <OgcLayerResult
                v-bind:layer="result"
                v-bind:layerType="resultList.type"
                v-bind:selectedLayerList="selectedLayerList"
                v-on:selectLayer="selectLayer($event)"
              />
            </div>
          </div>
          <div class="result_footer">
            <b-pagination @change="pageChange($event)"
              v-if="isCsw && resultList.nbTotalResults > pagingInfos.pageSize"
              v-model="pagingInfos.currentPage"
              align="center"
              class="mb-0"
              :total-rows="resultList.nbTotalResults"
              :per-page="pagingInfos.pageSize"
            ></b-pagination>
        </div>
        </div>
      </b-tab>

      <b-tab
        v-if="generalConfig.geojson"
        title="GeoJson"
        title-link-class="custom-tabs"
      >
        <br>
        <p>Pour ajouter un fichier Geojson, fermer cette fenêtre et glisser simplement
          le fichier sur la carte</p>
        <div>
            <hr>
            <i>Ou renseignez l'url du fichier et validez</i>
            <FormTextInput v-bind:label="'Url du fichier:'"  :cols="5" :md="5" :labelcols="2"
              v-model="geojsonUrl"> <b-button variant="info" class="bg_color-second mt-2" size="sm"
                title="Valider" @click="addGeoJsonLayer()">
                Valider&nbsp;<b-icon icon="arrow-right-circle"/>
              </b-button></FormTextInput>
        </div>
      </b-tab>
    </b-tabs>

   <template #modal-footer>
     <b-container fluid align-v="center" class="mb-2 button-bottom">
       <b-row :class="tabIndex === 2 && resultList !== null ? 'spc-btwn': 'cntr'">
          <!-- display if on the third tab, this should correspond to OGC, if tabs order to be modified, index should be adapted -->
          <b-button
            v-if="tabIndex === 2 && resultList !== null"
              variant="outline-primary"
              class="bg_color-first-outlined m-1"
              title="Retour"
              size="sm"
              @click="back()"
            >
            <b-icon icon="arrow-left"/>&nbsp;Retour
          </b-button>
          <div>
            <b-button
              v-if="resultList!=null &&
                resultList.layers.length>0 &&
                  resultList.type === 'WMS'"
              class="m-1"
              size="sm"
              variant="success"
              @click="checkLayers(resultList)"
            >
              vérifier la validité des couches du service
            </b-button>
            <b-button class="m-1" v-if="hasVectorTileFormat()"
              size="sm" variant="success" @click="addVectorTile()">
              Ajouter en vecteur tuilé
            </b-button>
            <b-button class="m-1" v-if="selectedLayerList.length >0"
              size="sm" variant="success" @click="appendLayerToMap()">
              Ajouter à la carte
            </b-button>
            <b-button class="m-1"  v-if="resultList!=null"
              size="sm" variant="danger" @click="close()">
              Fermer
            </b-button>
          </div>
        </b-row>
      </b-container>
    </template>
  </b-modal>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-this-alias */
/* eslint-disable no-undef */
/* eslint-disable class-methods-use-this */
/* eslint-disable prefer-template */
/* eslint-disable object-shorthand */
/* eslint-disable no-param-reassign */
import Component from 'vue-class-component';
import ModalPanel from '@/components/shared/ModalPanel.vue';
import AuthenticationInfoPanel from '@/components/shared/AuthenticationInfoPanel.vue';
import OgcLayerResult from '@/components/layers/add-layer-panel/OgcLayerResult.vue';
import CatalogSearch from '@/components/layers/add-layer-panel/CatalogSearch.vue';
import LayerConfig from '@/models/map-context/LayerConfig';
import AuthenticationInfos from '@/models/map-context/AuthenticationInfos';
import { RemoteServer, OGCLayer, CapabilitiesResponse } from '@/models/RemoteServer';
import EventBus, { EVENTS } from '@/services/EventBus';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import { Subject } from 'rxjs';
import { debounceTime } from 'rxjs/operators';
import BaseComponent from '../../BaseComponent';

@Component({
  props: {
  },
  components: {
    ModalPanel,
    OgcLayerResult,
    FormTextInput,
    CatalogSearch,
    AuthenticationInfoPanel,
  },
})
export default class AddLayerPanel extends BaseComponent {
  url='';// 'https://pigma.org/geoserver/wms?request=GetCapabilities&version=1.3.0';

  loading=false;

  tabIndex=0;

  resultList:CapabilitiesResponse|null=null;

  selectedLayerList:OGCLayer[]=[];

  selectedServer:RemoteServer|null=null;

  currentUrl = '';

  serverList=[];

  errorTxt:string|null=null;

  filter='';

  layerList:OGCLayer[]=[];

  showAuthInfos = false;

  authenticationInfos = new AuthenticationInfos();

  generalConfig:any =null;

  geojsonUrl = '';

  isCsw = false;

  filterTextChange = new Subject<string>();

  /**
   * paging parameters.
   */
  pagingInfos = {
    pageSize: 50,
    currentPage: 1,
    nbPages: 1,
  };

  filterChange():void {
    console.log('filter change');
    const self = this;
    if (this.isCsw) {
      this.filterTextChange.next(this.filter);
    } else if (this.resultList !== null) {
      this.layerList = this.filterList(
        JSON.parse(JSON.stringify(this.resultList.layers)), self.filter,
      );
    }
  }

  filterList(layerList:OGCLayer[], filter:string):OGCLayer[] {
    const retour:OGCLayer[] = [];
    layerList.forEach((element:OGCLayer) => {
      if (element.Layer) {
        element.Layer = this.filterList(element.Layer, filter);
        if (element.Layer.length > 0) {
          retour.push(element);
        }
      } else if (element.Title.toLowerCase().indexOf(filter.toLowerCase()) >= 0) {
        retour.push(element);
      }
      console.log(element);
    });
    return retour;
  }

  mounted() :void {
    this.generalConfig = this.contextService.configuration.addLayers;
    this.filterTextChange.pipe(debounceTime(1000))
      .subscribe((res) => this.pageChange(this.pagingInfos.currentPage));
    this.contextService.loadOGCServerList().then((reponse) => {
      console.log(reponse.data);
      this.serverList = reponse.data.serverList.map((x:any) => ({ value: x, text: x.nom }));
    });
  }

  pageChange(page:number):void {
    this.pagingInfos.currentPage = page;
    this.loading = true;
    this.connectCSW(this.url);
  }

  isSelected(result:OGCLayer): boolean {
    if (this.selectedLayerList.length === 0) {
      return false;
    }
    return this.selectedLayerList.find((x:OGCLayer) => x.Title === result.Title) !== undefined;
  }

  selectOGCServer() :void{
    if (this.selectedServer !== null) {
      this.url = this.selectedServer.url;
      const authInfos = this.contextService.getAuthInfos()[this.selectedServer.url];
      console.log(authInfos);
      if (authInfos !== undefined) {
        this.authenticationInfos = new AuthenticationInfos(authInfos);
      }
      if (this.selectedServer.type === 'CSW') {
        console.log('csw service detected');
        this.isCsw = true;
        this.connectCSW(this.selectedServer.url);
      } else {
        this.isCsw = false;
        this.getCapabilities(this.selectedServer.url);
      }
    }
  }

  connectServer() :void{
    console.log('connect', this.url);
    let capabilitiesUrl = this.url.trim();
    if (capabilitiesUrl.length === 0 && this.selectedServer !== null) {
      capabilitiesUrl = this.selectedServer.url;
    }
    if (capabilitiesUrl.length === 0) {
      this.error('Veuillez renseigner une url ou choisir un serveur dans la liste');
    } else {
      const searchMask = 'getCapabilities';
      const regEx = new RegExp(searchMask, 'ig');
      if (!regEx.test(capabilitiesUrl)) {
        if (capabilitiesUrl.indexOf('?') > 0) {
          capabilitiesUrl = `${capabilitiesUrl}&request=getCapabilities`;
        } else {
          capabilitiesUrl = `${capabilitiesUrl}?request=getCapabilities`;
        }
      }
      if (capabilitiesUrl.indexOf('/csw') > 0) {
        console.log('csw service detected');
        this.isCsw = true;
        this.connectCSW(capabilitiesUrl);
      } else {
        this.isCsw = false;
        const serviceSearchMask = 'service=';
        const serviceRegEx = new RegExp(serviceSearchMask, 'ig');
        if (!serviceRegEx.test(capabilitiesUrl)) {
          capabilitiesUrl = `${capabilitiesUrl}&service=wms`;
        }
        this.getCapabilities(capabilitiesUrl);
      }
    }
  }

  connectCSW(url:string) {
    let filterTxt = 'protocol=\'OGC:WMS-1.1.1-http-get-map\' OR protocol=\'OGC:WMS\'';

    if (this.filter.length > 0) {
      filterTxt = `(${filterTxt}) AND title Like '%${this.filter}%'`;
    }

    const startPos = (this.pagingInfos.currentPage - 1) * this.pagingInfos.pageSize + 1;
    url = url.replace('getCapabilities', 'GetRecords');
    const params = `&service=CSW&version=2.0.2&typeNames=csw:Record&resultType=results&maxRecords=${this.pagingInfos.pageSize}&startPosition=${startPos}&ELEMENTSETNAME=full`;
    const filter = encodeURIComponent(filterTxt);
    const cswurl = url
          + params
          + '&constraintLanguage=CQL_TEXT&CONSTRAINT_LANGUAGE_VERSION=1.1.0&CONSTRAINT='
          + filter;
    const self = this;
    const headers:any = {};
    if (this.authenticationInfos
      && this.authenticationInfos.isFilled()) {
      headers.Authorization = this.authenticationInfos.getBasicAutorisationValue();
    }
    this.loading = true;
    this.capabilitiesService.getRecords(cswurl, headers)
      .subscribe(
        (data:any) => {
          console.log(data);
          self.resultList = data;
          if (self.resultList !== null) {
            self.layerList = self.resultList.layers;
          }

          self.loading = false;
        },
        (error:any) => {
          console.log(error);
          this.error(error);
          this.loading = false;
        },
      );
  }

  selectLayer(layer:any) :void{
    // this.empty
    console.log(`Select Layer ${layer}`);
    if (this.selectedLayerList.indexOf(layer) >= 0) {
      this.selectedLayerList.splice(this.selectedLayerList.indexOf(layer), 1);
    } else {
      this.selectedLayerList.push(layer);
    }
  }

  selectCatalogLayer(layer:OGCLayer) :void{
    if (this.selectedLayerList.indexOf(layer) >= 0) {
      this.selectedLayerList.splice(this.selectedLayerList.indexOf(layer), 1);
    } else {
      this.selectedLayerList.push(layer);
    }

    const url:any = layer.Url;
    this.currentUrl = url;
    this.resultList = {
      type: 'WMS',
      useProxy: false,
      layers: [],
    };
    console.log(`Select Catalog Layer ${layer}`);
  }

  get resultsLoaded() :boolean {
    return this.layerList.length > 0 || this.filter.length > 0;
  }

  back() :void{
    this.resultList = null;
    this.filter = '';
    this.layerList = [];
  }

  addVectorTile():void{
    this.appendLayerToMap(true);
  }

  addOSM():void{
    const newLayer = new LayerConfig({
      layername: 'OSM',
      title: 'OSM',
      type: 'OSM',
      visible: true,
      Attribution: { Title: 'OSM' },
    });
    this.addLayerToMap(newLayer);
  }

  addGeoJsonLayer():void {
    const newLayer = new LayerConfig({
      layername: '',
      title: 'Nouvelle couche JSON',
      type: 'Vector',
      visible: true,
      boundingBoxEPSG4326: [-175, -85, 175, 85],
      url: this.geojsonUrl,
    });
    this.addLayerToMap(newLayer);
  }

  addVectorTilePlanIGN(style: string):void{
    const newLayer = new LayerConfig({
      layername: 'plan_ign',
      url: 'https://wxs.ign.fr/essentiels/geoportail/tms/1.0.0/PLAN.IGN/{z}/{x}/{y}.pbf',
      mbStyleUrl: 'https://wxs.ign.fr/static/vectorTiles/styles/PLAN.IGN/essentiels/' + style + '.json',
      metadataUrl: 'https://geoservices.ign.fr/planign',
      description: '',
      queryable: false,
      title: 'Vecteur Tuilé Plan IGN',
      popupInfos: { content: '{layer}', active: true, edited: false },
      protocol: 'TMS',
      type: 'VectorTile',
      visible: true,
      boundingBoxEPSG4326: [-175, -85, 175, 85],
      Attribution: { Title: '© IGN', OnlineResource: 'https://www.ign.fr' },
    });
    this.addLayerToMap(newLayer);
  }

  addIGN():void{
    const newLayer = new LayerConfig({
      layername: 'GEOGRAPHICALGRIDSYSTEMS.PLANIGNV2',
      url: 'https://wxs.ign.fr/cartes/geoportail/wmts?SERVICE=WMTS&VERSION=1.0.0&REQUEST=GetCapabilities',
      metadataUrl: 'https://geoservices.ign.fr/planign',
      description: 'Cartographie multi-échelles sur le territoire national, issue des bases de données vecteur de l’IGN, mis à jour régulièrement et réalisée selon un processus entièrement automatisé.',
      title: 'Plan IGN',
      type: 'WMTS',
      visible: true,
      boundingBoxEPSG4326: [-175, -85, 175, 85],
      Attribution: { Title: '© IGN', OnlineResource: 'https://www.ign.fr' },
    });
    this.addLayerToMap(newLayer);
  }

  addIGNOrtho():void{
    const newLayer = new LayerConfig({
      layername: 'ORTHOIMAGERY.ORTHOPHOTOS',
      url: 'https://wxs.ign.fr/essentiels/geoportail/wmts?SERVICE=WMTS&VERSION=1.0.0&REQUEST=GetCapabilities',
      metadataUrl: 'https://wxs.ign.fr/essentiels/geoportail/wmts?SERVICE=WMTS&VERSION=1.0.0&REQUEST=GetCapabilities',
      description: 'Photographies aériennes',
      title: 'Photographies aériennes',
      type: 'WMTS',
      boundingBoxEPSG4326: [-175, -85, 175, 85],
      visible: true,
      Attribution: { Title: '© IGN', OnlineResource: 'https://www.ign.fr' },
    });
    this.addLayerToMap(newLayer);
  }

  appendLayerToMap(vectorTile = false) :void{
    if (this.selectedLayerList.length > 0 && this.resultList != null) {
      // eslint-disable-next-line prefer-destructuring
      const resultList = this.resultList;
      this.selectedLayerList.forEach((selectedLayer) => {
        let outputFormat;
        if (selectedLayer.outputFormat) {
          outputFormat = selectedLayer.outputFormat;
        }
        if (selectedLayer.Format && selectedLayer.Format.indexOf('image/png') >= 0) {
          outputFormat = 'image/png';
        }
        console.log(selectedLayer.outputFormat);
        let projection = this.getMapService().map_projection_code;
        let dataProjection;
        if (selectedLayer.CRS
        && (selectedLayer.CRS.indexOf(this.getMapService().map_projection_code) >= 0)) {
          projection = this.getMapService().map_projection_code;
          // eslint-disable-next-line prefer-destructuring
          dataProjection = selectedLayer.CRS[0];
        } else if (selectedLayer.CRS && Array.isArray(selectedLayer.CRS)) {
        // eslint-disable-next-line prefer-destructuring
          projection = selectedLayer.CRS[0];
          // eslint-disable-next-line prefer-destructuring
          dataProjection = selectedLayer.CRS[0];
        } else if (selectedLayer.CRS) {
          projection = selectedLayer.CRS;
          dataProjection = selectedLayer.CRS;
        }

        console.log(selectedLayer);
        let url = this.currentUrl;
        if (selectedLayer.Url) {
          url = selectedLayer.Url;
        }
        let { type } = resultList;
        if (selectedLayer.Type) {
          type = selectedLayer.Type;
        }
        const newLayer = new LayerConfig({
          layername: selectedLayer.Name,
          url,
          title: selectedLayer.Title,
          description: selectedLayer.Abstract,
          type,
          outputFormat: outputFormat,
          visible: true,
          projection: projection,
          dataProjection: dataProjection,
          Attribution: selectedLayer.Attribution,
          maxScaleDenominator: selectedLayer.MaxScaleDenominator,
          minScaleDenominator: selectedLayer.MinScaleDenominator,
          boundingBoxEPSG4326: undefined,
        });

        if (vectorTile) {
          newLayer.type = 'VectorTile';
          if (selectedLayer.Format && selectedLayer.Format.indexOf('application/vnd.mapbox-vector-tile') >= 0) {
            newLayer.outputFormat = 'application/vnd.mapbox-vector-tile';
          } else if (selectedLayer.Format && selectedLayer.Format.indexOf('application/x-protobuf;type=mapbox-vector') >= 0) {
            newLayer.outputFormat = 'application/x-protobuf;type=mapbox-vector';
          } else {
            newLayer.outputFormat = 'application/x-protobuf';
          }
        }
        if (selectedLayer.MetadataURL && selectedLayer.MetadataURL.length > 0) {
          newLayer.metadataUrl = selectedLayer.MetadataURL[0].OnlineResource;
        }
        if (resultList.useProxy) {
          newLayer.url = this.contextService.getProxyFiedUrl(this.currentUrl);
        }

        if (this.authenticationInfos.isFilled()) {
          newLayer.authenticationInfos = new AuthenticationInfos({ ...this.authenticationInfos });
        }

        this.computeBbox(newLayer, selectedLayer);
        if (this.resultList != null && this.resultList.type === 'WMTS') {
          newLayer.layername = selectedLayer.Identifier;
        }
        console.log(newLayer);

        this.addLayerToMap(newLayer);
      });
      this.selectedLayerList = [];
    }
  }

  private addLayerToMap(newLayer: LayerConfig) {
    try {
      this.contextService.getCurrentContext().getLayers().unshift(newLayer);
      this.getMapService().addLayer(newLayer);
    } catch (error) {
      this.error(error);
    }
  }

  hasVectorTileFormat() :boolean {
    return this.selectedLayerList.length > 0
      && this.selectedLayerList.find((x:OGCLayer) => x.Format && (x.Format.indexOf('application/x-protobuf;type=mapbox-vector') >= 0
        || x.Format.indexOf('application/vnd.mapbox-vector-tile') >= 0
        || x.Format.indexOf('application/x-protobuf') >= 0)) !== undefined;
  }

  private computeBbox(newLayer: LayerConfig, selectedLayer:OGCLayer) {
    if (this.resultList != null && this.resultList.type === 'WMTS') {
      let bbox = selectedLayer.WGS84BoundingBox;
      if (bbox) {
        for (let i = 0; i < bbox.length; i += 1) {
          bbox[i] = +bbox[i].toFixed(3);
        }
      } else {
        bbox = [-180.0, -90.0, 180.0, 90.0];
      }
      newLayer.boundingBoxEPSG4326 = bbox;
    } else {
      const bbox = selectedLayer.EX_GeographicBoundingBox;
      for (let i = 0; i < bbox.length; i += 1) {
        bbox[i] = +bbox[i].toFixed(3);
      }
      newLayer.boundingBoxEPSG4326 = bbox;
    }
  }

  error(error:any) :void{
    console.log(error);
    this.errorTxt = error;
  }

  checkLayers(capabilitiesResponse:CapabilitiesResponse) :void{
    // Vérifie que les couches répondent au GetMap
    EventBus.$emit(EVENTS.INFO, 'Tests des 15 premières couches du service en cours...');
    capabilitiesResponse.layers.slice(0, 15).forEach((element:OGCLayer) => {
      if (element.Layer === undefined) { // s'il ne s'agit pas d'un groupe de couche
        console.log(element);
        let url = this.currentUrl + '&request=GetMap&layers=' + element.Name + '&width=256&height=256&format=image/jpeg&srs=EPSG%3A4326&bbox=-145.15104058007,21.731919794922,-57.154894212888,58.961058642578';
        const searchMask = 'request(=|%3D)getCapabilities';
        const regEx = new RegExp(searchMask, 'ig');
        const replaceMask = '';

        url = url.replace(regEx, replaceMask);
        this.contextService.loadUrl(url)
          .then((res) => {
            if (res.data.indexOf && res.data.indexOf('Exception') > 0) {
              element.status = 'Réponse à une requete GetMap KO';
            } else {
              element.status = 'OK (Réponse à une requete GetMap)';
            }
          },
          (res) => {
            console.log('ko');
            element.status = 'Réponse à une requete GetMap KO';
          });
      }
    });
  }

  close() :void{
    this.contextService.setCurrentAction('', []);
  }

  getCapabilities(url: string) :void{
    const self = this;
    const headers:any = {};
    if (this.authenticationInfos
      && this.authenticationInfos.isFilled()) {
      headers.Authorization = this.authenticationInfos.getBasicAutorisationValue();
    }
    this.loading = true;
    this.currentUrl = url;
    this.capabilitiesService.getCapabilities(url, headers, true)
      .subscribe(
        (data:any) => {
          console.log(data);
          self.resultList = data;
          if (self.resultList !== null) {
            self.layerList = self.resultList.layers;
          }

          self.loading = false;
        },
        (error:any) => {
          console.log(error);
          this.error(error);
          this.loading = false;
        },
      );
  }
}
</script>

<style scoped lang="less">
@import "../../../styles/variables.less";

img{
  background-color: #214282;
}
.img_caption{
  cursor: pointer;
  position: absolute;
  top: 10%;
  left: 20%;
  width: 60%;
  text-align: center;
  overflow: hidden;
  text-overflow: ellipsis;
  background-color: rgba(255,255,255,0.6);
  backdrop-filter: blur(10px) opacity(50%);
  border-radius: .25em;
  padding: 10px;
}

.cntr {
  justify-content: center;
}
.spc-btwn {
  justify-content: space-between;
}

</style>
